import sys
import serial
import xbee

def usage():
	print("Usage:")
	print("\tpython serial_read.py <PORT>")
	print("\tpython serial_read.py <PORT> <OUTPUT FILE>")

def main():
	file_flag = False

	number_of_args = len(sys.argv)
	if number_of_args < 2:
		usage()
		return

	port_name = sys.argv[1]

	if number_of_args == 3:
		file_flag = True
		filename = sys.argv[2]
		writer = xbee.Writer(filename)

	try:
		port = serial.Serial(port_name, 38400)
	except:
		print("[!] Unable to open port. Make sure you've entered the correct port name.")
		return

	reader = xbee.Reader(port)

	while True:
		try:
			frame = reader.read_frame()
		except KeyboardInterrupt:
			quit()

		if frame != -1:
			if file_flag == True:
				writer.write(frame)
			else:
				frame.print_frame()


if __name__ == "__main__":
	main()